diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_svs.c bcnet-ircd-1.2.2/modules/m_svs.c
--- ircd-ratbox-1.4-2/modules/m_svs.c	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/modules/m_svs.c	Sun May  9 10:35:58 2004
@@ -0,0 +1,243 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, doc/example_module.c
+ *   Copyright (C) 2001 Hybrid Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svs.c,v 1.6 2003/11/05 18:29:47 jeremy Exp $
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+#include "s_user.h"  /* send_umode_out() */
+#include "channel_mode.h" /* MODE_ADD & MOD_DEL */
+#include "hash.h"
+
+static void ms_svshost(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void mo_svshost(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void remove_host(struct Client *, char *);
+static void change_host(struct Client *, char *, char *);
+
+/* CHGHOST/SVSHOST/SETHOST */
+struct Message svshost_msgtab = {
+  "SVSHOST", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svshost, m_ignore}
+};
+struct Message chghost_msgtab = {
+  "CHGHOST", 0, 0, 2, 3, MFLG_SLOW, 0,
+  {m_ignore, m_not_oper, m_ignore, mo_svshost}
+};
+struct Message sethost_msgtab = {
+  "SETHOST", 0, 0, 2, 3, MFLG_SLOW, 0,
+  {m_ignore, m_not_oper, m_ignore, mo_svshost}
+};
+
+#ifndef STATIC_MODULES
+/* Here we tell it what to do when the module is loaded */
+void
+_modinit(void)
+{
+  /* This will add the commands in test_msgtab (which is above) */
+  /* SVSHOST/CHGHOST/SETHOST */
+  mod_add_cmd(&svshost_msgtab);
+//  mod_add_cmd(&chghost_msgtab);
+//  mod_add_cmd(&sethost_msgtab);
+}
+
+/* here we tell it what to do when the module is unloaded */
+void
+_moddeinit(void)
+{
+  /* This will remove the commands in test_msgtab (which is above) */
+  /* SVSHOST/CHGHOST/SETHOST */
+  mod_del_cmd(&svshost_msgtab);
+//  mod_del_cmd(&chghost_msgtab);
+//  mod_del_cmd(&sethost_msgtab);
+}
+
+/* When we last modified the file (shown in /modlist), this is usually:
+ */
+const char *_version = "$Revision: 1.6 $";
+#endif
+
+/*
+ * mo_svshost
+ *      parv[0] = sender prefix
+ *      parv[1] = target nickname
+ *      parv[2] = new hostname
+ */
+static void mo_svshost(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+  struct Client *target_p;
+  char *nick, hostname[HOSTLEN+1];
+  int remove = 0;
+
+  nick = parv[1];
+
+  if(parc > 2)
+    strlcpy(hostname, parv[2], HOSTLEN);
+
+  if(!isalpha(nick[0]))
+    if(nick[0] == '-')
+      remove = 1;
+
+  if(remove > 0)
+    {
+      nick++;
+      remove_host(source_p, nick);
+    }
+  else
+    {
+      if (parc != 3)
+        {
+          sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, source_p->name, "CHGHOST");
+          return;
+        }
+      change_host(source_p, nick, (hostname)? hostname : NULL);
+    }
+
+  return;
+}
+
+static void remove_host(struct Client *source_p, char *nick)
+{
+  struct Client *target_p;
+
+  if ((target_p = find_client(nick)) == NULL)
+    {
+      sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, source_p->name, target_p->name);
+      return;
+    }
+
+  strcpy(target_p->host, target_p->rhost);
+
+  sendto_one(source_p, "Reset %s's Host", target_p->name);
+  return;
+}
+
+static void change_host(struct Client *source_p, char *nick, char *host)
+{
+  struct Client *target_p;
+  char oldhost[HOSTLEN+1];
+  int setflags;
+
+  if ((target_p = find_client(nick)) == NULL)
+    {
+      sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, source_p->name, nick);
+      return;
+    }
+
+  /* check at this point for a valid hostname, and if its null
+     which it shouldn't be at this point */
+  if (!valid_hostname(host) || (host == NULL) || (strlen(host) > HOSTLEN))
+    {
+      sendto_one(source_p, "%s :Invalid Hostname", host);
+      return;
+    }
+
+  if(!strchr(host, '.') && !strchr(host, ':'))
+    {
+      sendto_one(source_p, "Hostname's must contain one . or :");
+      return;
+    }
+
+  /* Preserve the old hostname until we are finished */
+  strcpy(oldhost, target_p->host);
+
+  /* Prevent any unnecessary bursts */
+  if(!strcmp(oldhost, host))
+    {
+      sendto_one(source_p, "%s :Hostname Identical", host);
+      return;
+    }
+
+  if(MyClient(target_p) && IsMasked(target_p))
+    {
+      setflags = target_p->umodes;
+      target_p->umodes &= ~UMODE_IPMASK;
+      send_umode_out(target_p, target_p, setflags);
+    }
+
+  strcpy(target_p->host, host);
+  sendto_realops_flags(UMODE_ALL, L_ALL, "CHGHOST was used on %s (%s -> %s)", nick, oldhost, host);
+  ilog(L_NOTICE, "%s changed %s's hostname (%s -> %s)", source_p->name, nick, oldhost, host);
+  sendto_server(NULL, NULL, CAP_IPMASK, NOCAPS, ":%s SVSHOST %s %s %s", source_p->name, target_p->name, oldhost, host);
+
+  sendto_one(source_p, "Changed %s's Host (%s -> %s)", nick, oldhost, host);
+  return;
+}
+
+/*
+ * ms_svshost
+ *      parv[0] = sender prefix
+ *      parv[1] = target nickname
+ *      parv[2] = new hostname
+ */
+static void ms_svshost(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+  struct Client *target_p;
+  char *nick;
+  int setflags;
+  nick = parv[1];
+
+  if (parc != 4)
+    return;
+
+  sendto_server(client_p, NULL, CAP_IPMASK, NOCAPS, ":%s SVSHOST %s %s %s", parv[0], parv[1], parv[2], parv[3]);
+
+  target_p = find_client(nick);  
+  strcpy(target_p->host, parv[3]);
+
+  if(!IsServer(client_p))
+    {
+      sendto_realops_flags(UMODE_ALL, L_ALL, "CHGHOST was used on %s (%s -> %s)", nick, parv[2], parv[3]);
+      ilog(L_NOTICE, "%s changed %s's hostname (%s -> %s)", parv[0], nick, parv[2], parv[3]);
+    }
+  else
+    {
+      /* Changing the host on a masked user?
+         if so pull +X */
+      if(MyClient(target_p) && IsMasked(target_p))
+        {
+          setflags = target_p->umodes;
+          target_p->umodes &= ~UMODE_IPMASK;
+          send_umode_out(target_p, target_p, setflags);
+        }
+      ilog(L_NOTICE, "Caught SVSHOST from server [%s], Possibly a change of UMODE_ISMASK", parv[0]);
+    }
+
+  return;
+}
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_whois.c bcnet-ircd-1.2.2/modules/m_whois.c
--- ircd-ratbox-1.4-2/modules/m_whois.c	Sun Apr  4 08:44:55 2004
+++ bcnet-ircd-1.2.2/modules/m_whois.c	Sun May  9 10:35:58 2004
@@ -303,6 +303,9 @@
 		   target_p->username, target_p->host, target_p->info);
 	server_name = (char *) target_p->user->server;
 
+  if((IsOper(source_p)) || (source_p == target_p))
+    sendto_one(source_p, form_str(RPL_WHOISHOST), me.name, source_p->name, target_p->name, target_p->rhost);
+
 	cur_len = mlen = ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name);
 	t = buf + mlen;
 
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_whowas.c bcnet-ircd-1.2.2/modules/m_whowas.c
--- ircd-ratbox-1.4-2/modules/m_whowas.c	Mon Mar 15 13:19:50 2004
+++ bcnet-ircd-1.2.2/modules/m_whowas.c	Sun May  9 10:35:58 2004
@@ -154,6 +154,10 @@
 				sendto_one(source_p, form_str(RPL_WHOISSERVER),
 					   me.name, parv[0], temp->name,
 					   temp->servername, myctime(temp->logoff));
+
+          if(IsOper(source_p))
+            sendto_one(source_p, form_str(RPL_WHOWASREALHOST), me.name, parv[0], temp->name, temp->hostname, temp->rhostname);
+
 			cur++;
 			found++;
 		}
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/channel.c bcnet-ircd-1.2.2/src/channel.c
--- ircd-ratbox-1.4-2/src/channel.c	Mon Apr 26 13:47:43 2004
+++ bcnet-ircd-1.2.2/src/channel.c	Sun May  9 10:35:57 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel.c,v 7.381.2.11 2004/04/26 17:47:43 leeh Exp $
+ *  $Id: channel.c,v 7.381.2.10 2004/04/07 20:37:49 androsyn Exp $
  */
 
 #include "stdinc.h"
@@ -892,13 +892,6 @@
 static void
 finish_splitmode(void *unused)
 {
-        /* dropped back into a netsplit during split_delay --fl */
-	if(Count.server < split_servers || Count.total < split_users)
-	{
-		eventAddIsh("check_splitmode", check_splitmode, NULL, 10);
-		return;
-	}
-
 	splitmode = 0;
 
 	sendto_realops_flags(UMODE_ALL, L_ALL,
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/client.c bcnet-ircd-1.2.2/src/client.c
--- ircd-ratbox-1.4-2/src/client.c	Wed Mar 24 19:30:54 2004
+++ bcnet-ircd-1.2.2/src/client.c	Sun May  9 10:35:57 2004
@@ -1541,7 +1541,7 @@
 		if(IsPerson(source_p))
 			sendto_realops_flags(UMODE_CCONN, L_ALL,
 					     "Client exiting: %s (%s@%s) [%s] [%s]",
-					     source_p->name, source_p->username, source_p->host,
+					     source_p->name, source_p->username, source_p->rhost,
 					     comment,
 #ifdef HIDE_SPOOF_IPS
 					     IsIPSpoof(source_p) ? "255.255.255.255" :
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/hostmask.c bcnet-ircd-1.2.2/src/hostmask.c
--- ircd-ratbox-1.4-2/src/hostmask.c	Tue Mar 23 12:35:54 2004
+++ bcnet-ircd-1.2.2/src/hostmask.c	Sun May  9 10:35:57 2004
@@ -454,6 +454,9 @@
 	aconf = find_conf_by_address(client_p->host, &client_p->localClient->ip,
 				     CONF_KILL, client_p->localClient->aftype, client_p->username);
 
+	if (!aconf)
+		aconf = find_conf_by_address(client_p->rhost, &client_p->localClient->ip, CONF_KILL, client_p->localClient->aftype, client_p->username);
+
 	return aconf;
 }
 
@@ -470,6 +473,9 @@
 
 	aconf = find_conf_by_address(client_p->host, &client_p->localClient->ip,
 				     CONF_GLINE, client_p->localClient->aftype, client_p->username);
+
+	if (!aconf)
+		aconf = find_conf_by_address(client_p->rhost, &client_p->localClient->ip, CONF_GLINE, client_p->localClient->aftype, client_p->username);
 
 	return aconf;
 }
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/ipmask.c bcnet-ircd-1.2.2/src/ipmask.c
--- ircd-ratbox-1.4-2/src/ipmask.c	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/src/ipmask.c	Sun May  9 10:35:57 2004
@@ -0,0 +1,248 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  FreeWorld-ircd:
+ *  ipmask.c: IP Masking routines.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: ipmask.c,v 1.2 2003/10/20 06:30:42 ircd Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "s_user.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "class.h"
+#include "client.h"
+#include "common.h"
+#include "fdlist.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "sprintf_irc.h"
+#include "ircd.h"
+#include "listener.h"
+#include "motd.h"
+#include "ircd_handler.h"
+#include "msg.h"
+#include "numeric.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_stats.h"
+#include "scache.h"
+#include "send.h"
+#include "supported.h"
+#include "whowas.h"
+#include "memory.h"
+#include "packet.h"
+
+void maskip (struct Client *);
+int calculate_ip (struct Client *);
+
+void maskip (struct Client *client_p)
+{
+	char buf[HOSTLEN];
+	int i = 0,j = 0,k = 0;
+	char *tmp = NULL;
+	char *tmp2 = NULL;
+	char *tmp3 = NULL;
+	char *tmp4 = NULL;
+	static char mask[HOSTLEN];
+
+	strlcpy(buf, client_p->rhost, HOSTLEN);
+	j = strlen(buf);
+    mask[0] = '\0';
+
+	if(strchr(buf, '.'))
+	{
+		k = calculate_ip (client_p);
+		if(!isdigit(buf[j - 1]))
+		{
+			tmp = strchr(buf, '.');
+			*tmp = '\0';
+			tmp++;
+			tmp2 = strchr(tmp, '.');
+
+			if(tmp2 != NULL)
+				ircsprintf(mask, "%s-%d.%s", ServerInfo.network_name, k, tmp);
+
+		}
+		else
+		{
+			tmp = strrchr(buf, '.');
+			*tmp = '\0';
+			tmp--;
+
+			ircsprintf(mask, "%s.%d", buf, k);
+		}
+
+		if (mask[0] != '\0') {
+			sendto_realops_flags(UMODE_DEBUG, L_ALL, "Applying mask (%s) to %s", mask, client_p->name);
+			strlcpy(client_p->host, mask, HOSTLEN);
+		}
+	}
+
+
+#ifdef IPV6
+	if(strchr(buf, ':'))
+	{
+		tmp = strrchr(buf, ':');
+		*tmp = '\0';
+		tmp--;
+		tmp2 = strrchr(tmp, ':');
+
+		if(tmp2 != NULL)
+		{
+			tmp3 = strrchr(tmp2, ':');
+
+			if(tmp3 != NULL)
+			{
+				tmp4 = strrchr(tmp3, ':');
+				*tmp4 = '\0';
+				tmp4--;
+			}
+			ircsprintf(mask, "%s::IPV6", buf);
+		}
+
+		if (mask[0] != '\0') {
+			sendto_realops_flags(UMODE_DEBUG, L_ALL, "Applying mask (%s) to %s", mask, client_p->name);
+			strlcpy(client_p->host, mask, HOSTLEN);
+		}
+	}
+#endif
+
+}
+
+int calculate_ip (struct Client *client_p)
+{
+  char buffer[BUFSIZE];
+  char *tmp, *tmp2, *tmp3;
+  int a,b,c,d,e;
+
+/*  if (!MyClient(client_p))
+    return;*/
+
+  strcpy(buffer, client_p->localClient->sockhost);
+
+  if (strchr(buffer, ':'))
+    return 0;
+
+  if ((tmp = strchr(buffer, '.')) != NULL)
+  {
+    *tmp = '\0';
+    tmp++;
+
+    if ((tmp2 = strchr(tmp, '.')) != NULL)
+    {
+      *tmp2 = '\0';
+      tmp2++;
+
+      if ((tmp3 = strchr(tmp2, '.')) != NULL)
+      {
+        *tmp3 = '\0';
+        tmp3++;
+      }
+    }
+  }
+
+  a = atoi(buffer);
+  b = atoi(tmp);
+  c = atoi(tmp2);
+  d = atoi(tmp3);
+
+  e = a + b + c + d;
+  e = e * e * 1024 % 100000;
+
+  return e;
+}
+
+char *ret_maskip(struct Client *client_p)
+{
+        char buf[HOSTLEN];
+        int i = 0,j = 0,k = 0;
+        char *tmp = NULL;
+        char *tmp2 = NULL;
+        char *tmp3 = NULL;
+        char *tmp4 = NULL;
+        static char mask[HOSTLEN];
+
+        strlcpy(buf, client_p->rhost, HOSTLEN);
+        j = strlen(buf);
+        mask[0] = '\0';
+  
+        if(strchr(buf, '.'))
+        {
+                k = calculate_ip (client_p);
+                if(!isdigit(buf[j - 1]))
+                {
+                        tmp = strchr(buf, '.');
+                        *tmp = '\0';
+                        tmp++;
+                        tmp2 = strchr(tmp, '.');
+  
+                        if(tmp2 != NULL)
+                                ircsprintf(mask, "%s-%d.%s", ServerInfo.network_name, k, tmp);
+
+			else
+			    ircsprintf (mask, "%s-%d.%s", ServerInfo.network_name, k, buf);
+			    //strcpy (mask, client_p->host);
+ 
+                }
+                else
+                {
+                        tmp = strrchr(buf, '.');
+                        *tmp = '\0';
+                        tmp--;
+  
+                        ircsprintf(mask, "%s.%d", buf, k);
+                }  
+
+        }
+
+
+#ifdef IPV6
+        if(strchr(buf, ':'))
+        {
+                tmp = strrchr(buf, ':');
+                *tmp = '\0';
+                tmp--;
+                tmp2 = strrchr(tmp, ':');
+
+                if(tmp2 != NULL)
+                {
+                        tmp3 = strrchr(tmp2, ':');
+
+                        if(tmp3 != NULL)
+                        {
+                                tmp4 = strrchr(tmp3, ':');
+                                *tmp4 = '\0';
+                                tmp4--;
+                        }
+                        ircsprintf(mask, "%s::IPV6", buf);
+                }  
+
+        }
+#endif
+
+	if (mask[0] != '\0')
+		return mask;
+	else
+		return client_p->host;
+}
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/messages.tab bcnet-ircd-1.2.2/src/messages.tab
--- ircd-ratbox-1.4-2/src/messages.tab	Mon Apr  5 15:22:56 2004
+++ bcnet-ircd-1.2.2/src/messages.tab	Sun May  9 10:35:57 2004
@@ -24,7 +24,7 @@
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglZ biklmnopstveI bkloveI",
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglZX biklmnopstveI bkloveI",
 /* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
 /* 006 */       NULL,
 /* 007 */       NULL,
@@ -394,7 +394,7 @@
 /* 367 RPL_BANLIST, */          ":%s 367 %s %s %s %s %lu",
 /* 368 RPL_ENDOFBANLIST, */     ":%s 368 %s %s :End of Channel Ban List",
 /* 369 RPL_ENDOFWHOWAS, */      ":%s 369 %s %s :End of WHOWAS",
-/* 370 */       NULL,
+/* 370 RPL_WHOWASREALHOST, */   ":%s 370 %s :%s was connected from *@%s [%s]", 
 /* 371 RPL_INFO, */             ":%s 371 %s :%s",
 /* 372 RPL_MOTD, */             ":%s 372 %s :- %s",
 /* 373 RPL_INFOSTART, */        ":%s 373 %s :Server INFO",
@@ -402,7 +402,7 @@
 /* 375 RPL_MOTDSTART, */        ":%s 375 %s :- %s Message of the Day - ",
 /* 376 RPL_ENDOFMOTD, */        ":%s 376 %s :End of /MOTD command.",
 /* 377 */       NULL,
-/* 378 */       NULL,
+/* 378 RPL_WHOISHOST */         ":%s 378 %s :%s is connected from *@%s",
 /* 379 */       NULL,
 /* 380 */       NULL,
 /* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered... the Vanity Zone!.",
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/newconf.c bcnet-ircd-1.2.2/src/newconf.c
--- ircd-ratbox-1.4-2/src/newconf.c	Wed Apr  7 16:37:50 2004
+++ bcnet-ircd-1.2.2/src/newconf.c	Sun May  9 10:35:57 2004
@@ -112,6 +112,8 @@
 	{"restricted", CONF_FLAGS_RESTRICTED},
 	{"need_ident", CONF_FLAGS_NEED_IDENTD},
 	{"have_ident", CONF_FLAGS_NEED_IDENTD},
+	{"mask", CONF_FLAGS_IPMASK},
+	{"mask_notice", CONF_FLAGS_MASK_NOTICE},
 	{NULL}
 };
 
@@ -1412,6 +1414,28 @@
 	DupString(yy_achead->className, data);
 }
 
+static void
+conf_set_auth_mask(void *data)
+{
+	int yesno = *(unsigned int *) data;
+
+	if (yesno)
+		yy_achead->flags |= CONF_FLAGS_IPMASK;
+	else
+		yy_achead->flags &= ~CONF_FLAGS_IPMASK;
+}
+
+static void
+conf_set_auth_mask_notice (void *data)
+{
+	int yesno = *(unsigned int *) data;
+
+	if (yesno)
+		yy_achead->flags |= CONF_FLAGS_MASK_NOTICE;
+	else
+		yy_achead->flags &= ~CONF_FLAGS_MASK_NOTICE;
+}
+
 static int
 conf_begin_resv(struct TopConf *tc)
 {
@@ -3066,6 +3090,8 @@
 	add_conf_item("auth", "flood_exempt", CF_YESNO, conf_set_auth_flood_exempt);
 	add_conf_item("auth", "redirserv", CF_QSTRING, conf_set_auth_redir_serv);
 	add_conf_item("auth", "redirport", CF_INT, conf_set_auth_redir_port);
+	add_conf_item("auth", "mask", CF_YESNO, conf_set_auth_mask);
+	add_conf_item("auth", "mask_notice", CF_YESNO, conf_set_auth_mask_notice);
 	add_conf_item("auth", "flags", CF_STRING | CF_FLIST, conf_set_auth_flags);
 
 	add_top_conf("resv", conf_begin_resv, conf_end_resv);
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/s_conf.c bcnet-ircd-1.2.2/src/s_conf.c
--- ircd-ratbox-1.4-2/src/s_conf.c	Thu Apr 22 14:42:06 2004
+++ bcnet-ircd-1.2.2/src/s_conf.c	Sun May  9 10:35:57 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.c,v 7.416.2.25 2004/04/22 18:42:06 leeh Exp $
+ *  $Id: s_conf.c,v 7.416.2.24 2004/04/07 20:37:50 androsyn Exp $
  */
 
 #include "stdinc.h"
@@ -56,6 +56,7 @@
 #include "patricia.h"
 #include "reject.h"
 
+char *ret_maskip(struct Client *);
 
 struct config_server_hide ConfigServerHide;
 
@@ -535,6 +536,16 @@
 		if(IsConfRestricted(aconf))
 			SetRestricted(client_p);
 
+
+		strlcpy (client_p->rhost, client_p->host, sizeof(client_p->rhost));
+		if(IsConfDoMaskIp(aconf))
+		{
+			strcpy (client_p->host, ret_maskip(client_p));
+			client_p->umodes |= UMODE_IPMASK;
+			if(IsConfMaskNotice(aconf))
+				sendto_realops_flags (UMODE_ALL, L_ALL, "%s masking: %s as %s", client_p->name, client_p->rhost, client_p->host);
+		}
+
 		/* Thanks for spoof idea amm */
 		if(IsConfDoSpoofIp(aconf))
 		{
@@ -1320,7 +1331,7 @@
 
 	ConfigChannel.default_split_user_count = 0;
 	ConfigChannel.default_split_server_count = 0;
-	ConfigChannel.default_split_delay = 60;
+	ConfigChannel.default_split_delay = 15;
 	ConfigChannel.no_join_on_split = NO;
 	ConfigChannel.no_create_on_split = YES;
 
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/s_serv.c bcnet-ircd-1.2.2/src/s_serv.c
--- ircd-ratbox-1.4-2/src/s_serv.c	Sun Apr 11 22:08:18 2004
+++ bcnet-ircd-1.2.2/src/s_serv.c	Sun May  9 10:35:57 2004
@@ -95,6 +95,7 @@
 	{ "UNKLN",	CAP_UNKLN },
 	{ "CLUSTER",	CAP_CLUSTER },
 	{ "ENCAP",	CAP_ENCAP },
+	{ "IPMASK", CAP_IPMASK },
 	{ 0, 		0 }
 };
 
@@ -790,13 +791,15 @@
 		ubuf[1] = '\0';
 	}
 
-		sendto_one(client_p, "NICK %s %d %lu %s %s %s %s :%s",
+		sendto_one(client_p, "NICK %s %d %lu %s %s %s %s %s :%s",
 			   target_p->name,
 			   target_p->hopcount + 1,
 			   (unsigned long) target_p->tsinfo,
 			   ubuf,
 			   target_p->username, target_p->host,
-			   target_p->user->server, target_p->info);
+			   target_p->user->server,
+			   IsCapable (client_p, CAP_IPMASK)? target_p->rhost : "", target_p->info);
+
 }
 
 /*
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/s_user.c bcnet-ircd-1.2.2/src/s_user.c
--- ircd-ratbox-1.4-2/src/s_user.c	Fri Apr  2 10:51:02 2004
+++ bcnet-ircd-1.2.2/src/s_user.c	Sun May  9 10:35:57 2004
@@ -54,11 +54,13 @@
 #include "memory.h"
 #include "packet.h"
 #include "reject.h"
+#include "hostmask.h"
 
 static void report_and_set_user_flags(struct Client *, struct ConfItem *);
 static int check_X_line(struct Client *client_p, struct Client *source_p);
 void user_welcome(struct Client *source_p);
 int oper_up(struct Client *source_p, struct ConfItem *aconf);
+char *ret_maskip(struct Client *);
 
 extern char *crypt();
 
@@ -88,6 +90,7 @@
 	{UMODE_UNAUTH, 'u'},
 	{UMODE_WALLOP, 'w'},
 	{UMODE_EXTERNAL, 'x'},
+    {UMODE_IPMASK, 'X'},
 	{UMODE_SPY, 'y'},
 	{UMODE_OPERWALL, 'z'},
 	{UMODE_OPERSPY, 'Z'},
@@ -462,7 +465,7 @@
 		 ipaddr, HOSTIPLEN);
 	sendto_realops_flags(UMODE_CCONN, L_ALL,
 			     "Client connecting: %s (%s@%s) [%s] {%s} [%s]",
-			     nick, source_p->username, source_p->host,
+			     nick, source_p->username, source_p->rhost,
 #ifdef HIDE_SPOOF_IPS
 			     IsIPSpoof(source_p) ? "255.255.255.255" :
 #endif
@@ -608,13 +611,21 @@
 		ubuf[1] = '\0';
 	}
 
-	sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+	sendto_server(client_p, NULL, NOCAPS, CAP_IPMASK,
 		      "NICK %s %d %lu %s %s %s %s :%s",
 		      nick, source_p->hopcount + 1, 
 		      (unsigned long) source_p->tsinfo, ubuf, 
 		      source_p->username, source_p->host, user->server,
 		      source_p->info);
 
+    sendto_server(client_p, NULL, CAP_IPMASK, NOCAPS,
+              "NICK %s %d %lu %s %s %s %s %s :%s",
+              nick, source_p->hopcount + 1,
+              (unsigned long) source_p->tsinfo, ubuf,
+              source_p->username, source_p->host, user->server,
+			  source_p->rhost,
+              source_p->info);
+
 	return 0;
 }
 
@@ -841,7 +852,7 @@
  */
 int
 do_remote_user(char *nick, struct Client *client_p, struct Client *source_p,
-	       char *username, char *host, char *server, char *realname)
+	       char *username, char *host, char *server, char *rhost, char *realname)
 {
 	unsigned int oflags;
 	struct User *user;
@@ -862,6 +873,11 @@
 	strlcpy(source_p->host, host, sizeof(source_p->host));
 	strlcpy(source_p->info, realname, sizeof(source_p->info));
 
+	if(rhost)
+		strlcpy(source_p->rhost, rhost, sizeof(source_p->rhost));
+	else
+		strlcpy(source_p->rhost, "unavailable", sizeof(source_p->rhost));
+
 	return register_remote_user(client_p, source_p, source_p->name, username);
 }
 
@@ -882,7 +898,8 @@
 	struct Client *target_p;
 	int what, setflags;
 	int badflag = NO;	/* Only send one bad flag notice */
-	char buf[BUFSIZE];
+	char buf[BUFSIZE], oldhost[HOSTLEN];
+	struct ConfItem* aconf;
 
 	what = MODE_ADD;
 
@@ -984,6 +1001,47 @@
 					}
 				}
 				break;
+
+				case 'X':
+				if (MyClient(source_p))
+				{
+					aconf = find_address_conf (source_p->rhost, source_p->username, &source_p->localClient->ip, source_p->localClient->aftype);
+
+					strcpy (oldhost, source_p->host);
+
+					if(what == MODE_ADD)
+					{
+						if(IsConfDoSpoofIp(aconf))
+						{
+							source_p->umodes &= ~UMODE_IPMASK;
+							break;
+						}
+
+						if(IsMasked(source_p))
+						{
+							if(!strcmp(ret_maskip(source_p), source_p->host))
+								break;
+
+							source_p->umodes |= UMODE_IPMASK;
+							strcpy(source_p->host, ret_maskip(source_p));
+						}
+
+						source_p->umodes |= UMODE_IPMASK;
+						strcpy(source_p->host, ret_maskip(source_p));
+					}
+
+					if(what == MODE_DEL)
+					{
+						if(!IsMasked(source_p))
+							break;
+
+						source_p->umodes &= ~UMODE_IPMASK;
+						strcpy(source_p->host, source_p->rhost);
+					}
+
+					sendto_server (NULL, NULL, CAP_IPMASK, NOCAPS, ":%s SVSHOST %s %s %s", me.name, source_p->name, oldhost, source_p->host);
+			}
+			break;
 
 			case 'p':
 				if (MyConnect(source_p))
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/version.c.SH bcnet-ircd-1.2.2/src/version.c.SH
--- ircd-ratbox-1.4-2/src/version.c.SH	Sun Jul  6 11:01:03 2003
+++ bcnet-ircd-1.2.2/src/version.c.SH	Sun May  9 10:35:57 2004
@@ -52,10 +52,12 @@
 #include "patchlevel.h"
 #include "serno.h"
 
+#define PATCHVER PATCHLEVEL "+ipmask-1.4"
+
 const char *generation = "$generation";
 const char *creation = "$creation";
 const char *platform = "$uname";
-const char *ircd_version = PATCHLEVEL;
+const char *ircd_version = PATCHVER;
 const char *serno = SERIALNUM;
 
 const char *infotext[] =
diff -uNrd -x CVS ircd-ratbox-1.4-2/src/whowas.c bcnet-ircd-1.2.2/src/whowas.c
--- ircd-ratbox-1.4-2/src/whowas.c	Mon Mar 15 13:19:57 2004
+++ bcnet-ircd-1.2.2/src/whowas.c	Sun May  9 10:35:57 2004
@@ -88,6 +88,7 @@
 	strlcpy(who->name, client_p->name, sizeof(who->name));
 	strcpy(who->username, client_p->username);
 	strcpy(who->hostname, client_p->host);
+	strcpy(who->rhostname, client_p->rhost);
 	strcpy(who->realname, client_p->info);
 
 	who->servername = client_p->user->server;
